cr = 
[[

  =======  Login System Version 1.0  =======

  Copyright 2014 by Alex2009(www.Alex2009.de)

  Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz. 
  Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de
  ueber diese Lizenz hinausgehende Erlaubnisse koennen Sie unter http://www.Alex2009.de erhalten.

  HINWEIS: Das Entschluesseln dieser Datei ist nach Paragraph 202b und Paragraph 202c StGB strafbar.
  
  
  
]]

LoginSystem = {};
LoginSystem.dir = g_currentModDirectory;
InitObjectClass(LoginSystem, "LoginSystem");

function LoginSystem:loadMap(name)
    registerObjectClassName(self, "LoginSystem");
    g_currentMission.LoginSystemInfo = self;
    print("[Login System by Alex2009.de v1.0] Loading...");
    if g_currentMission.missionDynamicInfo.isMultiplayer then
        g_currentMission.LoginSystemInfo.isDediServer = (g_dedicatedServerInfo ~= nil);
        g_currentMission.LoginSystemInfo.userTable = {};
        g_currentMission.LoginSystemInfo.loginFehlerhaft = {};
        g_currentMission.LoginSystemInfo.loggedIn = false;
        g_currentMission.LoginSystemInfo.hasAccount = false;
        g_currentMission.LoginSystemInfo.userKicked = false;
        if g_currentMission.LoginSystemInfo.isDediServer then
            g_currentMission.LoginSystemInfo.userXML = getUserProfileAppPath().."LoginSystem.xml";
            if not fileExists(g_currentMission.LoginSystemInfo.userXML) then
                print("[Login System by Alex2009.de v1.0] Create LoginSystem.xml...");
                local file = io.open(g_currentMission.LoginSystemInfo.userXML, "w")
                if file ~= nil then
                    file:write('<?xml version="1.0" encoding="utf-8" standalone="no" ?>\n\n')
                    file:write('<!--\n    ======  Login System Version 1.0  ======\n\n');
                    file:write('    Copyright 2014 by Alex2009(www.Alex2009.de)\n\n');
                    file:write('    Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz.\n');
                    file:write('    Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de\n');
                    file:write('    ueber diese Lizenz hinausgehende Erlaubnisse koennen Sie unter http://www.Alex2009.de erhalten.\n-->\n\n');
                    file:write('<LoginSystem registerEnabled="true">\n    <Users>\n    </Users>\n</LoginSystem>\n');
                    file:close();
                    print("[Login System by Alex2009.de v1.0] LoginSystem.xml created.");
                else
                    print("[Login System by Alex2009.de v1.0] ERROR: Cant't create LoginSystem.xml!");
                    return;
                end;
            end;
            local userXML = loadXMLFile("users",g_currentMission.LoginSystemInfo.userXML);
            local regAllowed = Utils.getNoNil(getXMLBool(userXML,"LoginSystem#registerEnabled"),true);
            print("[Login System by Alex2009.de v1.0] Register Enabled: "..tostring(regAllowed));
            g_currentMission.LoginSysRegisterAllowed = regAllowed;
            local int = 0;
            while true do
                local userLine = string.format("LoginSystem.Users.User(%d)", int)
                if not hasXMLProperty(userXML, userLine) then
                    break;
                end
                local userName = getXMLString(userXML,userLine.."#username");
                local userpw = getXMLString(userXML,userLine.."#password");
                g_currentMission.LoginSystemInfo.userTable[userName] = userpw;
                int=int+1;
                print("[Login System by Alex2009.de v1.0] Load User: "..userName);
            end;
        else
            print("[Login System by Alex2009.de v1.0] Loading GUI...");
            g_LGSySLoginScreen = LGSySLoginScreen:new();
            g_gui:loadGui(LoginSystem.dir.."LoginScreen.xml", "LGSySLoginScreen", g_LGSySLoginScreen)
            g_LGSySRegisterScreen = LGSySRegisterScreen:new();
            g_gui:loadGui(LoginSystem.dir.."RegisterScreen.xml", "LGSySRegisterScreen", g_LGSySRegisterScreen)
            print("[Login System by Alex2009.de v1.0] GUI loaded");
            print("[Login System by Alex2009.de v1.0] Adding Admin GUI Addon...");
            
            local GUIxml = loadXMLFile("GUI",LoginSystem.dir.."AdminGameScreenAddOn.xml");
            local newGui = ToggleButtonElement:new(AdminGameScreen);
            newGui:loadFromXML(GUIxml,string.format("GUI.GuiElement(%d)",0))
            g_gui.guis["AdminGameScreen"]:addElement(newGui)
            g_gui:loadGuiRec(GUIxml,string.format("GUI.GuiElement(%d)",0), newGui, g_adminGameScreen)
            g_gui.guis["AdminGameScreen"].registerAllowed = newGui;
            newGui = nil;
            
            local newGui = TextElement:new(AdminGameScreen);
            newGui:loadFromXML(GUIxml,string.format("GUI.GuiElement(%d)",1))
            g_gui.guis["AdminGameScreen"]:addElement(newGui)
            g_gui.guis["AdminGameScreen"]:updateAbsolutePosition()
            newGui = nil;
            print("[Login System by Alex2009.de v1.0] Admin GUI Addon added");
        end;
    else
        print("[Login System by Alex2009.de v1.0] It is not a Multiplayer game");
    end;
    print("[Login System by Alex2009.de v1.0] Loaded");
end;

local oldAdminGameScreenOnOpen = g_gui.guis["AdminGameScreen"].onOpen;
g_gui.guis["AdminGameScreen"].onOpen = function(self)
    g_gui.guis["AdminGameScreen"].registerAllowed:setIsChecked(g_currentMission.LoginSysRegisterAllowed)
    oldAdminGameScreenOnOpen(g_gui.guis["AdminGameScreen"]);
end;

function LoginSystem:keyEvent(unicode, sym, modifier, isDown)
end;

function LoginSystem:mouseEvent(posX, posY, isDown, isUp, button)
end;

function LoginSystem:deleteMap() 
    unregisterObjectClassName(self); 
    g_currentMission.LoginSystemInfo.isDediServer = (g_dedicatedServerInfo ~= nil);
    g_currentMission.LoginSystemInfo.userTable = nil;
    g_currentMission.LoginSystemInfo.userTable = {};
    g_currentMission.LoginSystemInfo.loginFehlerhaft = nil;
    g_currentMission.LoginSystemInfo.loginFehlerhaft = {};
    g_currentMission.LoginSystemInfo.loggedIn = false;
    g_currentMission.LoginSystemInfo.hasAccount = false;
    g_currentMission.LoginSystemInfo.userKicked = false;
end;

function LoginSystem:update(dt)
    if g_currentMission.missionDynamicInfo.isMultiplayer then
        if not g_currentMission.LoginSystemInfo.isDediServer and not g_currentMission.LoginSystemInfo.loggedIn and g_gui.currentGui == nil then
            if g_currentMission.LoginSystemInfo.hasAccount then
                g_LGSySLoginScreen:setCallbacks(g_currentMission.LoginSystemInfo.login, g_currentMission.LoginSystemInfo)
                g_gui:showGui("LGSySLoginScreen")
            else
                g_LGSySRegisterScreen:setCallbacks(g_currentMission.LoginSystemInfo.register, g_currentMission.LoginSystemInfo)
                g_gui:showGui("LGSySRegisterScreen");
            end;
        elseif g_currentMission.LoginSystemInfo.isDediServer and not g_currentMission.LoginSystemInfo.userKicked then   
            for i = 1, table.getn(g_currentMission.users) do
                if not g_currentMission.LoginSysRegisterAllowed and g_currentMission.LoginSystemInfo.userTable[g_currentMission.users[i].nickname] == nil and g_currentMission.users[i].nickname ~= g_settingsNickname then
                    g_currentMission:kickUser(g_currentMission.users[i]);
                end;
            end;
            g_currentMission.LoginSystemInfo.userKicked = true;
        end;
    end;
end;

local oldBaseMissionReadyEventReadStreamLogSys = BaseMissionReadyEvent.readStream;
BaseMissionReadyEvent.readStream = function(self, streamId, connection)
    if connection:getIsServer() then
        g_currentMission.LoginSysRegisterAllowed = streamReadBool(streamId);
        local tableCount = streamReadInt32(streamId);
        local int = 1;
        for int=1,tableCount,1 do
            local userName = streamReadString(streamId);
            local loginAllowed = streamReadBool(streamId);
            if userName == g_settingsNickname then
                g_currentMission.LoginSystemInfo.hasAccount = loginAllowed;
            end;
        end;
    end;
    oldBaseMissionReadyEventReadStreamLogSys(self, streamId, connection);
end;

local oldBaseMissionReadyEventWriteStreamLogSys = BaseMissionReadyEvent.writeStream;
BaseMissionReadyEvent.writeStream = function(self, streamId, connection)
    if not connection:getIsServer() then
        streamWriteBool(streamId,g_currentMission.LoginSysRegisterAllowed);
        self.userKicked = false;
        local count = 0;
        for playerName,PW in pairs(g_currentMission.LoginSystemInfo.userTable) do
            count=count+1;
        end;
        streamWriteInt32(streamId,count);
        for playerName,PW in pairs(g_currentMission.LoginSystemInfo.userTable) do
            streamWriteString(streamId,playerName);
            streamWriteBool(streamId,(g_currentMission.LoginSystemInfo.userTable[playerName] ~= nil and g_currentMission.LoginSystemInfo.userTable[playerName] ~= ""));
        end;
    end;
    oldBaseMissionReadyEventWriteStreamLogSys(self, streamId, connection);
end;

function LoginSystem:login(password)
    g_client:getServerConnection():sendEvent(LGSySLoginEvent:new(g_settingsNickname, getMD5(password))); 
end;

function LoginSystem:register(password)
    g_client:getServerConnection():sendEvent(LGSySLoginEvent:new(g_settingsNickname, getMD5(password), false));
    g_currentMission.LoginSystemInfo.hasAccount = true;
    g_client:getServerConnection():sendEvent(LGSySLoginEvent:new(g_settingsNickname, getMD5(password))); 
    if g_gui.currentGui ~= nil then
        g_gui:showGui("")
    end;    
end;

function LoginSystem:registerServerEvent(username,password)
    if g_currentMission.LoginSysRegisterAllowed then
        local userXML = loadXMLFile("users",g_currentMission.LoginSystemInfo.userXML);
        local int = 0;
        while true do
            local userLine = string.format("LoginSystem.Users.User(%d)", int)
            if not hasXMLProperty(userXML, userLine) then
                break;
            end;
            int=int+1;
        end;
        print("[Login System by Alex2009.de v1.0] "..tostring(username).." registered.");
        local userLine = string.format("LoginSystem.Users.User(%d)", int)
        setXMLString(userXML,userLine.."#username",username);
        setXMLString(userXML,userLine.."#password",password);
        saveXMLFile(userXML);
        g_currentMission.LoginSystemInfo.userTable[username] = password;
    end;
end;

function LoginSystem:loginServerEvent(username,password)
    if g_currentMission.LoginSystemInfo.isDediServer then
        if g_currentMission.LoginSystemInfo.loginFehlerhaft[username] == nil then
            g_currentMission.LoginSystemInfo.loginFehlerhaft[username] = 0;
        end;
        local loginCorrect = false;
        if g_currentMission.LoginSystemInfo.userTable[username] ~= nil then
            if g_currentMission.LoginSystemInfo.userTable[username] == password then
                loginCorrect = true;
                g_server:broadcastEvent(LGSySLoggedinEvent:new(username, true));
                g_server:broadcastEvent(ChatEvent:new(tostring(username).." logged in.","LoginSystem"));
                print("[Login System by Alex2009.de v1.0] "..tostring(username).." logged in.");
            else
                g_currentMission.LoginSystemInfo.loginFehlerhaft[username] = g_currentMission.LoginSystemInfo.loginFehlerhaft[username] + 1;
                print("[Login System by Alex2009.de v1.0] "..tostring(username).." has an incorrect password entered");
            end;
        else
            g_currentMission.LoginSystemInfo.loginFehlerhaft[username] = g_currentMission.LoginSystemInfo.loginFehlerhaft[username] + 1;
            print("[Login System by Alex2009.de v1.0] "..tostring(username).." has an incorrect password entered");
        end;
        if g_currentMission.LoginSystemInfo.loginFehlerhaft[username] >= 3 and not loginCorrect then
            for i = 1, table.getn(g_currentMission.users) do
                if g_currentMission.users[i].nickname == username then
                    g_currentMission:kickUser(g_currentMission.users[i]);
                end;
            end;
            g_server:broadcastEvent(ChatEvent:new(tostring(username).." kicked after 3 login attempts","LoginSystem"));
            print("[Login System by Alex2009.de v1.0] "..tostring(username).." kicked after 3 login attempts");
        end;
    end;
end;

function LoginSystem:draw() 
end;
addModEventListener(LoginSystem);

local oldAdminGameScreenOnSaveClick = g_gui.guis["AdminGameScreen"].elements[1].elements[23].onClick;
g_gui.guis["AdminGameScreen"].elements[1].elements[23].onClick = function(self)
    if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
        g_currentMission.LoginSysRegisterAllowed = g_gui.guis["AdminGameScreen"].registerAllowed.isChecked;
        g_client:getServerConnection():sendEvent(LGSySRegStateEvent:new(g_gui.guis["AdminGameScreen"].registerAllowed.isChecked));
    end
    oldAdminGameScreenOnSaveClick(self);
end;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


LGSySLoginScreen = {}
local LGSySLoginScreen_mt = Class(LGSySLoginScreen)
function LGSySLoginScreen:new()
  local instance = GuiElement:new(target, LGSySLoginScreen_mt)
  return instance;
end;  
  
function LGSySLoginScreen:onLoginClick()
    self.callback(self.object, self.loginField.text)
    self.loginField:setText("");
end;

function LGSySLoginScreen:onCreatePWField(field)
    self.loginField = field;
end;

function LGSySLoginScreen:setCallbacks(callback, object)
  self.callback = callback;
  self.object = object
end;

function LGSySLoginScreen:onOpen()
    InputBinding.setShowMouseCursor(true)
end;

function LGSySLoginScreen:onClose()
    InputBinding.setShowMouseCursor(false)
end;

function LGSySLoginScreen:onCloseClick()
    OnInGameMenuMenu()
end;

function LGSySLoginScreen:update(dt)
end;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


LGSySRegisterScreen = {}
local LGSySRegisterScreen_mt = Class(LGSySRegisterScreen)
function LGSySRegisterScreen:new()
  local instance = GuiElement:new(target, LGSySRegisterScreen_mt)
  return instance;
end;  
  
function LGSySRegisterScreen:onLoginClick()
    if self.loginField1.text ~= self.loginField2.text then
        self.loginField1:setText("");
        self.loginField2:setText("");
    else
        self.callback(self.object, self.loginField1.text)
        self.loginField1:setText("");
        self.loginField2:setText("");
    end;
end;

function LGSySRegisterScreen:onCreatePWField1(field)
    self.loginField1 = field;
end;

function LGSySRegisterScreen:onCreatePWField2(field)
    self.loginField2 = field;
end;

function LGSySRegisterScreen:setCallbacks(callback, object)
  self.callback = callback;
  self.object = object
end;

function LGSySRegisterScreen:onOpen()
    InputBinding.setShowMouseCursor(true)
end;

function LGSySRegisterScreen:onClose()
    InputBinding.setShowMouseCursor(false)
end;

function LGSySRegisterScreen:onCloseClick()
    OnInGameMenuMenu()
end;

function LGSySRegisterScreen:update(dt)
end;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


LGSySLoginEvent = {};
LGSySLoginEvent_mt = Class(LGSySLoginEvent, Event);

InitEventClass(LGSySLoginEvent, "LGSySLoginEvent");

function LGSySLoginEvent:emptyNew()
    local self = Event:new(LGSySLoginEvent_mt);
    self.className = "LGSySLoginEvent";
    return self;
end;

function LGSySLoginEvent:new(username, password, login)
    local self = LGSySLoginEvent:emptyNew()
    self.username = username;
	self.password = password;
    self.login = login;
    return self;
end;

function LGSySLoginEvent:readStream(streamId, connection)
    self.username = streamReadString(streamId);
	self.password = streamReadString(streamId);
    self.login = streamReadBool(streamId);
    self:run(connection);
end;

function LGSySLoginEvent:writeStream(streamId, connection)
    streamWriteString(streamId, self.username);
	streamWriteString(streamId, self.password);
    if self.login == nil then
        self.login = true;
    end;
    streamWriteBool(streamId, self.login);
end;

function LGSySLoginEvent:run(connection)
    if self.login then
        g_currentMission.LoginSystemInfo:loginServerEvent(self.username,self.password);
    else    
        g_currentMission.LoginSystemInfo:registerServerEvent(self.username,self.password);
    end;
end;

function LGSySLoginEvent.sendEvent(username, password, login, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(LGSySLoginEvent:new(username, password, login));
        else
            g_client:getServerConnection():sendEvent(LGSySLoginEvent:new(username, password, login));
        end;
    end;
end;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


LGSySLoggedinEvent = {};
LGSySLoggedinEvent_mt = Class(LGSySLoggedinEvent, Event);

InitEventClass(LGSySLoggedinEvent, "LGSySLoggedinEvent");

function LGSySLoggedinEvent:emptyNew()
    local self = Event:new(LGSySLoggedinEvent_mt);
    self.className = "LGSySLoggedinEvent";
    return self;
end;

function LGSySLoggedinEvent:new(username, password)
    local self = LGSySLoggedinEvent:emptyNew()
    self.username = username;
	self.password = password;
    return self;
end;

function LGSySLoggedinEvent:readStream(streamId, connection)
    self.username = streamReadString(streamId);
	self.password = streamReadBool(streamId);
    self:run(connection);
end;

function LGSySLoggedinEvent:writeStream(streamId, connection)
    streamWriteString(streamId, self.username);
	streamWriteBool(streamId, self.password);
end;

function LGSySLoggedinEvent:run(connection)
    if self.username == g_settingsNickname then
        g_currentMission.LoginSystemInfo.loggedIn = self.password;
        if g_gui.currentGui ~= nil then
            g_gui:showGui("")
        end;
    end;
    if not connection:getIsServer() then
        g_server:broadcastEvent(LGSySLoggedinEvent:new(self.username, self.password));
    end;
end;

function LGSySLoggedinEvent.sendEvent(username, password, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(LGSySLoggedinEvent:new(username, password));
        else
            g_client:getServerConnection():sendEvent(LGSySLoggedinEvent:new(username, password));
        end;
    end;
end;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


LGSySRegStateEvent = {};
LGSySRegStateEvent_mt = Class(LGSySRegStateEvent, Event);

InitEventClass(LGSySRegStateEvent, "LGSySRegStateEvent");

function LGSySRegStateEvent:emptyNew()
    local self = Event:new(LGSySRegStateEvent_mt);
    self.className = "LGSySRegStateEvent";
    return self;
end;

function LGSySRegStateEvent:new(loginAllowed)
    local self = LGSySRegStateEvent:emptyNew()
    self.loginAllowed = loginAllowed;
    return self;
end;

function LGSySRegStateEvent:readStream(streamId, connection)
    self.loginAllowed = streamReadBool(streamId);
    self:run(connection);
end;

function LGSySRegStateEvent:writeStream(streamId, connection)
    streamWriteBool(streamId, self.loginAllowed);
end;

function LGSySRegStateEvent:run(connection)
    g_currentMission.LoginSysRegisterAllowed = self.loginAllowed;
    if g_currentMission.LoginSystemInfo.isDediServer then
        local userXML = loadXMLFile("users",g_currentMission.LoginSystemInfo.userXML);
        setXMLBool(userXML,"LoginSystem#registerEnabled",self.loginAllowed);
        saveXMLFile(userXML);
    end;   
    if not connection:getIsServer() then
        g_server:broadcastEvent(LGSySRegStateEvent:new(self.loginAllowed));
    end;
end;

function LGSySRegStateEvent.sendEvent(loginAllowed, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(LGSySRegStateEvent:new(loginAllowed));
        else
            g_client:getServerConnection():sendEvent(LGSySRegStateEvent:new(loginAllowed));
        end;
    end;
end;